"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.plugin = exports.ethereumPlugin = exports.EthereumPlugin = void 0;
/* eslint-disable import/no-extraneous-dependencies */
var resolvers_1 = require("./resolvers");
var w3_1 = require("./w3");
var Connection_1 = require("./Connection");
var Mapping = __importStar(require("./mapping"));
var core_js_1 = require("@web3api/core-js");
var ethers_1 = require("ethers");
var utils_1 = require("ethers/lib/utils");
var EthereumPlugin = /** @class */ (function (_super) {
    __extends(EthereumPlugin, _super);
    function EthereumPlugin(config) {
        var _this = _super.call(this) || this;
        _this._connections = Connection_1.Connection.fromConfigs(config.networks);
        // Assign the default network (mainnet if not provided)
        if (config.defaultNetwork) {
            _this._defaultNetwork = config.defaultNetwork;
        }
        else {
            _this._defaultNetwork = "mainnet";
        }
        // Create a connection for the default network if none exists
        if (!_this._connections[_this._defaultNetwork]) {
            _this._connections[_this._defaultNetwork] = Connection_1.Connection.fromNetwork(_this._defaultNetwork);
        }
        return _this;
    }
    EthereumPlugin.manifest = function () {
        return w3_1.manifest;
    };
    EthereumPlugin.prototype.getModules = function (_client) {
        return {
            query: resolvers_1.query(this),
            mutation: resolvers_1.mutation(this),
        };
    };
    /// Mutation
    EthereumPlugin.prototype.callContractMethod = function (input) {
        return __awaiter(this, void 0, void 0, function () {
            var res;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._callContractMethod(input)];
                    case 1:
                        res = _a.sent();
                        return [2 /*return*/, Mapping.toTxResponse(res)];
                }
            });
        });
    };
    EthereumPlugin.prototype.callContractMethodAndWait = function (input) {
        return __awaiter(this, void 0, void 0, function () {
            var response, res;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._callContractMethod(input)];
                    case 1:
                        response = _a.sent();
                        return [4 /*yield*/, response.wait()];
                    case 2:
                        res = _a.sent();
                        return [2 /*return*/, Mapping.toTxReceipt(res)];
                }
            });
        });
    };
    EthereumPlugin.prototype.sendTransaction = function (input) {
        return __awaiter(this, void 0, void 0, function () {
            var connection, signer, res;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getConnection(input.connection)];
                    case 1:
                        connection = _a.sent();
                        signer = connection.getSigner();
                        return [4 /*yield*/, signer.sendTransaction(Mapping.fromTxRequest(input.tx))];
                    case 2:
                        res = _a.sent();
                        return [2 /*return*/, Mapping.toTxResponse(res)];
                }
            });
        });
    };
    EthereumPlugin.prototype.sendTransactionAndWait = function (input) {
        return __awaiter(this, void 0, void 0, function () {
            var connection, signer, response, receipt;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getConnection(input.connection)];
                    case 1:
                        connection = _a.sent();
                        signer = connection.getSigner();
                        return [4 /*yield*/, signer.sendTransaction(Mapping.fromTxRequest(input.tx))];
                    case 2:
                        response = _a.sent();
                        return [4 /*yield*/, response.wait()];
                    case 3:
                        receipt = _a.sent();
                        return [2 /*return*/, Mapping.toTxReceipt(receipt)];
                }
            });
        });
    };
    EthereumPlugin.prototype.deployContract = function (input) {
        return __awaiter(this, void 0, void 0, function () {
            var connection, signer, factory, contract;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getConnection(input.connection)];
                    case 1:
                        connection = _a.sent();
                        signer = connection.getSigner();
                        factory = new ethers_1.ethers.ContractFactory(input.abi, input.bytecode, signer);
                        return [4 /*yield*/, factory.deploy.apply(factory, this.parseArgs(input.args))];
                    case 2:
                        contract = _a.sent();
                        return [4 /*yield*/, contract.deployTransaction.wait()];
                    case 3:
                        _a.sent();
                        return [2 /*return*/, contract.address];
                }
            });
        });
    };
    EthereumPlugin.prototype.signMessage = function (input) {
        return __awaiter(this, void 0, void 0, function () {
            var connection, messageHash, messageHashBytes;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getConnection(input.connection)];
                    case 1:
                        connection = _a.sent();
                        messageHash = ethers_1.ethers.utils.id(input.message);
                        messageHashBytes = ethers_1.ethers.utils.arrayify(messageHash);
                        return [4 /*yield*/, connection.getSigner().signMessage(messageHashBytes)];
                    case 2: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    EthereumPlugin.prototype.sendRPC = function (input) {
        return __awaiter(this, void 0, void 0, function () {
            var connection, provider, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getConnection(input.connection)];
                    case 1:
                        connection = _a.sent();
                        provider = connection.getProvider();
                        return [4 /*yield*/, provider.send(input.method, input.params)];
                    case 2:
                        response = _a.sent();
                        return [2 /*return*/, response.toString()];
                }
            });
        });
    };
    /// Query
    EthereumPlugin.prototype.callContractView = function (input) {
        return __awaiter(this, void 0, void 0, function () {
            var connection, contract, funcs, res;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getConnection(input.connection)];
                    case 1:
                        connection = _a.sent();
                        contract = connection.getContract(input.address, [input.method], false);
                        funcs = Object.keys(contract.interface.functions);
                        return [4 /*yield*/, contract[funcs[0]].apply(contract, this.parseArgs(input.args))];
                    case 2:
                        res = _a.sent();
                        return [2 /*return*/, res.toString()];
                }
            });
        });
    };
    EthereumPlugin.prototype.callContractStatic = function (input) {
        return __awaiter(this, void 0, void 0, function () {
            var connection, contract, funcs, res, e_1;
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.getConnection(input.connection)];
                    case 1:
                        connection = _b.sent();
                        contract = connection.getContract(input.address, [input.method]);
                        funcs = Object.keys(contract.interface.functions);
                        _b.label = 2;
                    case 2:
                        _b.trys.push([2, 4, , 5]);
                        return [4 /*yield*/, (_a = contract.callStatic)[funcs[0]].apply(_a, __spreadArrays(this.parseArgs(input.args), [{
                                    gasPrice: input.gasPrice
                                        ? ethers_1.ethers.BigNumber.from(input.gasPrice)
                                        : undefined,
                                    gasLimit: input.gasLimit
                                        ? ethers_1.ethers.BigNumber.from(input.gasLimit)
                                        : undefined,
                                    value: input.value ? ethers_1.ethers.BigNumber.from(input.value) : undefined,
                                }]))];
                    case 3:
                        res = _b.sent();
                        return [2 /*return*/, {
                                result: res.toString(),
                                error: false,
                            }];
                    case 4:
                        e_1 = _b.sent();
                        return [2 /*return*/, {
                                result: e_1.reason,
                                error: true,
                            }];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    EthereumPlugin.prototype.encodeParams = function (input) {
        return utils_1.defaultAbiCoder.encode(input.types, input.values);
    };
    EthereumPlugin.prototype.getSignerAddress = function (input) {
        return __awaiter(this, void 0, void 0, function () {
            var connection;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getConnection(input.connection)];
                    case 1:
                        connection = _a.sent();
                        return [4 /*yield*/, connection.getSigner().getAddress()];
                    case 2: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    EthereumPlugin.prototype.getSignerBalance = function (input) {
        return __awaiter(this, void 0, void 0, function () {
            var connection;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getConnection(input.connection)];
                    case 1:
                        connection = _a.sent();
                        return [4 /*yield*/, connection.getSigner().getBalance(input.blockTag || undefined)];
                    case 2: return [2 /*return*/, (_a.sent()).toString()];
                }
            });
        });
    };
    EthereumPlugin.prototype.getSignerTransactionCount = function (input) {
        return __awaiter(this, void 0, void 0, function () {
            var connection;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getConnection(input.connection)];
                    case 1:
                        connection = _a.sent();
                        return [4 /*yield*/, connection
                                .getSigner()
                                .getTransactionCount(input.blockTag || undefined)];
                    case 2: return [2 /*return*/, (_a.sent()).toString()];
                }
            });
        });
    };
    EthereumPlugin.prototype.getGasPrice = function (input) {
        return __awaiter(this, void 0, void 0, function () {
            var connection;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getConnection(input.connection)];
                    case 1:
                        connection = _a.sent();
                        return [4 /*yield*/, connection.getSigner().getGasPrice()];
                    case 2: return [2 /*return*/, (_a.sent()).toString()];
                }
            });
        });
    };
    EthereumPlugin.prototype.estimateTransactionGas = function (input) {
        return __awaiter(this, void 0, void 0, function () {
            var connection;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getConnection(input.connection)];
                    case 1:
                        connection = _a.sent();
                        return [4 /*yield*/, connection.getSigner().estimateGas(Mapping.fromTxRequest(input.tx))];
                    case 2: return [2 /*return*/, (_a.sent()).toString()];
                }
            });
        });
    };
    EthereumPlugin.prototype.estimateContractCallGas = function (input) {
        var _a, _b, _c;
        return __awaiter(this, void 0, void 0, function () {
            var connection, contract, funcs, gasPrice, gasLimit, value, gas;
            var _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0: return [4 /*yield*/, this.getConnection(input.connection)];
                    case 1:
                        connection = _e.sent();
                        contract = connection.getContract(input.address, [input.method]);
                        funcs = Object.keys(contract.interface.functions);
                        gasPrice = (_a = input.txOverrides) === null || _a === void 0 ? void 0 : _a.gasPrice;
                        gasLimit = (_b = input.txOverrides) === null || _b === void 0 ? void 0 : _b.gasLimit;
                        value = (_c = input.txOverrides) === null || _c === void 0 ? void 0 : _c.value;
                        return [4 /*yield*/, (_d = contract.estimateGas)[funcs[0]].apply(_d, __spreadArrays(this.parseArgs(input.args), [{
                                    gasPrice: gasPrice ? ethers_1.ethers.BigNumber.from(gasPrice) : undefined,
                                    gasLimit: gasLimit ? ethers_1.ethers.BigNumber.from(gasLimit) : undefined,
                                    value: value ? ethers_1.ethers.BigNumber.from(value) : undefined,
                                }]))];
                    case 2:
                        gas = _e.sent();
                        return [2 /*return*/, gas.toString()];
                }
            });
        });
    };
    EthereumPlugin.prototype.checkAddress = function (input) {
        var address = input.address;
        try {
            // If the address is all upper-case, convert to lower case
            if (address.indexOf("0X") > -1) {
                address = address.toLowerCase();
            }
            var result = ethers_1.ethers.utils.getAddress(address);
            if (!result) {
                return false;
            }
            return true;
        }
        catch (error) {
            return false;
        }
    };
    EthereumPlugin.prototype.toWei = function (input) {
        var weiAmount = ethers_1.ethers.utils.parseEther(input.eth);
        return weiAmount.toString();
    };
    EthereumPlugin.prototype.toEth = function (input) {
        var etherAmount = ethers_1.ethers.utils.formatEther(input.wei);
        return etherAmount.toString();
    };
    EthereumPlugin.prototype.waitForEvent = function (input) {
        return __awaiter(this, void 0, void 0, function () {
            var connection, contract, events, filter;
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.getConnection(input.connection)];
                    case 1:
                        connection = _b.sent();
                        contract = connection.getContract(input.address, [input.event]);
                        events = Object.keys(contract.interface.events);
                        filter = (_a = contract.filters)[events[0]].apply(_a, this.parseArgs(input.args));
                        return [2 /*return*/, Promise.race([
                                new Promise(function (resolve) {
                                    contract.once(filter, function (data, address, log) {
                                        resolve({
                                            data: data,
                                            address: address,
                                            log: Mapping.toLog(log),
                                        });
                                    });
                                }),
                                new Promise(function (_, reject) {
                                    setTimeout(function () {
                                        reject("Waiting for event \"" + input.event + "\" on contract \"" + input.address + "\" timed out");
                                    }, input.timeout || 60000);
                                }),
                            ])];
                }
            });
        });
    };
    EthereumPlugin.prototype.awaitTransaction = function (input) {
        return __awaiter(this, void 0, void 0, function () {
            var connection, provider, res;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getConnection(input.connection)];
                    case 1:
                        connection = _a.sent();
                        provider = connection.getProvider();
                        return [4 /*yield*/, provider.waitForTransaction(input.txHash, input.confirmations, input.timeout)];
                    case 2:
                        res = _a.sent();
                        return [2 /*return*/, Mapping.toTxReceipt(res)];
                }
            });
        });
    };
    /// Utils
    EthereumPlugin.prototype.getConnection = function (connection) {
        return __awaiter(this, void 0, void 0, function () {
            var networkNameOrChainId, node, result, networkStr, chainId, nodeConnection, nodeNetwork, establishedConnection;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!connection) {
                            return [2 /*return*/, this._connections[this._defaultNetwork]];
                        }
                        networkNameOrChainId = connection.networkNameOrChainId, node = connection.node;
                        // If a custom network is provided, either get an already
                        // established connection, or a create a new one
                        if (networkNameOrChainId) {
                            networkStr = networkNameOrChainId.toLowerCase();
                            if (this._connections[networkStr]) {
                                result = this._connections[networkStr];
                            }
                            else {
                                chainId = Number.parseInt(networkStr);
                                if (!isNaN(chainId)) {
                                    result = Connection_1.Connection.fromNetwork(chainId);
                                }
                                else {
                                    result = Connection_1.Connection.fromNetwork(networkStr);
                                }
                            }
                        }
                        else {
                            result = this._connections[this._defaultNetwork];
                        }
                        if (!node) return [3 /*break*/, 2];
                        nodeConnection = Connection_1.Connection.fromNode(node);
                        return [4 /*yield*/, nodeConnection.getProvider().getNetwork()];
                    case 1:
                        nodeNetwork = _a.sent();
                        establishedConnection = this._connections[nodeNetwork.chainId.toString()] ||
                            this._connections[nodeNetwork.name];
                        if (establishedConnection) {
                            try {
                                nodeConnection.setSigner(establishedConnection.getSigner());
                            }
                            catch (e) {
                                // It's okay if there isn't a signer available.
                            }
                        }
                        result = nodeConnection;
                        _a.label = 2;
                    case 2: return [2 /*return*/, result];
                }
            });
        });
    };
    EthereumPlugin.prototype.parseArgs = function (args) {
        if (!args) {
            return [];
        }
        return args.map(function (arg) {
            return (arg.startsWith("[") && arg.endsWith("]")) ||
                (arg.startsWith("{") && arg.endsWith("}"))
                ? JSON.parse(arg)
                : arg;
        });
    };
    EthereumPlugin.prototype._callContractMethod = function (input) {
        var _a, _b, _c;
        return __awaiter(this, void 0, void 0, function () {
            var connection, contract, funcs, gasPrice, gasLimit, value;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0: return [4 /*yield*/, this.getConnection(input.connection)];
                    case 1:
                        connection = _d.sent();
                        contract = connection.getContract(input.address, [input.method]);
                        funcs = Object.keys(contract.interface.functions);
                        gasPrice = (_a = input.txOverrides) === null || _a === void 0 ? void 0 : _a.gasPrice;
                        gasLimit = (_b = input.txOverrides) === null || _b === void 0 ? void 0 : _b.gasLimit;
                        value = (_c = input.txOverrides) === null || _c === void 0 ? void 0 : _c.value;
                        return [4 /*yield*/, contract[funcs[0]].apply(contract, __spreadArrays(this.parseArgs(input.args), [{
                                    gasPrice: gasPrice ? ethers_1.ethers.BigNumber.from(gasPrice) : undefined,
                                    gasLimit: gasLimit ? ethers_1.ethers.BigNumber.from(gasLimit) : undefined,
                                    value: value ? ethers_1.ethers.BigNumber.from(value) : undefined,
                                }]))];
                    case 2: return [2 /*return*/, _d.sent()];
                }
            });
        });
    };
    return EthereumPlugin;
}(core_js_1.Plugin));
exports.EthereumPlugin = EthereumPlugin;
exports.ethereumPlugin = function (opts) {
    return {
        factory: function () { return new EthereumPlugin(opts); },
        manifest: w3_1.manifest,
    };
};
exports.plugin = exports.ethereumPlugin;
//# sourceMappingURL=index.js.map